package com.jeeplus.modules.sg.managementcenter.project.util;
import com.jeeplus.modules.sg.managementcenter.project.entity.Project;
import com.jeeplus.modules.sys.utils.UserUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public  class ProExcelInfo {

    public static String[] PRO_TYPE={"配网资本","配网成本"};
    public static String[] PRO_NAME={"配电运检室","经研所","新区"};
    public static String[] PRO_CLARIFICAITON = {"施工单位自行交底","项目经理组织交底"};
    public static String[] PRO_POWERSCOPE={"670","67001+","67002+","67002-","67003-","68101-"};
    public static String[] PRO_PROJECT_TYPE={"配变改造","配变新增","电缆项目","杆线项目","混合项目","纯自动化","纯土建","井盖维修","环网柜更换","箱变更换","其他特殊类"};//项目类型
    public static String[] PRO_FLAG = {"是","否"};
    public static String[] PRO_PRE_JUDGEMENT = {"行政政处（城区道路）","民事政处/行政政处（公路/水利）","无","农村政处"};//政策初步判断
    public static String[] PRO_FLAG_CIVIL = {"可能有土建","无土建","含土建","纯土建"};//是否含土建
    public static String[] PRO_STEEL_TUBE = {"无","压桩","灌注桩"};//钢管杆基础类类型
    public static String[] PRO_EQU_TYPE = {"无","环网柜","箱变","干变","其他"};//设备改造类型
    public static String[] PRO_DRAWING_WORK = {"带电作业","停电作业","非涉电作业","未标注"};//图纸标注的带点作业情况
    public static String[] PRO_TWO_THREE = {"二遥","三遥"};//二或三
    public static String[] PRO_PHONE_STYLE = {"光纤","公网","专网"};//通信方式
    public static String[] PRO_STAY_AREA={"集中","就地"};//柱开集中或就业地
    public static String[] PRO_RING_NETWORK = {"户内","户外"};//环网柜

    /**
     * 获取表格数据
     * @param importUtil
     * @return List<ErpAccount> 导入表格数据
     */
    public static List<Project> getProjectUtil(ImportUtil importUtil)  {
        int lastRow = importUtil.getLastDataRowNum();
        List<Project> list = new ArrayList<Project>();
        Project project = null;
        String costEstimate="";//费用估算
        for(int i=2; i<=lastRow;i++){
            project = new Project();
            Row row = importUtil.getRow(i);
            String requireCode = (String) importUtil.getCellValue(row,5);
            if(StringUtils.isNotBlank(requireCode)) {
                project.setRequireName(requireCode);
                project.setType((String)importUtil.getCellValue(row,1));//类型
                project.setDemandUnit((String)importUtil.getCellValue(row,2));//需求提出单位
                project.setBdzName((String)importUtil.getCellValue(row,3));//变电站名称
                project.setLineName((String)importUtil.getCellValue(row,4));//线路名称
                project.setProjectId((String)importUtil.getCellValue(row,6));//工程编号
                project.setProjectName((String)importUtil.getCellValue(row,7));//项目名称
                project.setProjectNumber((String)importUtil.getCellValue(row,8));//项目定义号
                project.setProjectManageRole((String)importUtil.getCellValue(row,9));//项目经理角色

                project.setDistributionEngineering((String)importUtil.getCellValue(row,10));//配网工程专职角色
                project.setDistributionMaterials((String)importUtil.getCellValue(row,11));//配网物资专职角色
                project.setDistributionSystem((String)importUtil.getCellValue(row,12));//配网系统专职角色
                project.setDistributionPolicy((String)importUtil.getCellValue(row,13));//配网政策处理专职角色
                project.setManagementLeader((String)importUtil.getCellValue(row,14));//项目管理中心领导角色'
                project.setRunUnit((String)importUtil.getCellValue(row,15));//运行单位
                project.setRunUnitRole((String)importUtil.getCellValue(row,16));//运行单位角色
                project.setThroughResearchRole((String)importUtil.getCellValue(row,17));//经研所角色
                project.setConstructionUnit((String)importUtil.getCellValue(row,18));//施工单位
                project.setConstructionUnitRole((String)importUtil.getCellValue(row,19));//施工单位角色
                project.setDesignUnit((String)importUtil.getCellValue(row,20));//设计单位
                project.setDesignUnitRole((String)importUtil.getCellValue(row,21));//设计单位角色
                project.setClarificaitonType((String)importUtil.getCellValue(row,22));//交底类型
                project.setBulidClassificationResons((String)importUtil.getCellValue(row,23));//建设理由分类
                project.setBulbidResons((String)importUtil.getCellValue(row,24));//建设理由
                project.setAsicEquipment((String)importUtil.getCellValue(row,25));//设备基本状况
                project.setRunTheClass((String)importUtil.getCellValue(row,26));//运行班
                project.setProjectTeam((String)importUtil.getCellValue(row,27));//项目组
                costEstimate = (String) importUtil.getCellValue(row,28);
                if (null!=costEstimate&&!costEstimate.equals("")){
                    project.setCostEstimate(Double.parseDouble(costEstimate));//费用估算
                }
                project.setWhetherRheUpwind((String)importUtil.getCellValue(row,29));//是否迎风期度夏项目
                project.setSureDaDate((String)importUtil.getCellValue(row,30));//确定下达时间
                project.setTextRemark((String)importUtil.getCellValue(row,31));//备注
                project.setPowerLine((String)importUtil.getCellValue(row,32));//停电线路
                project.setPowerScope((String)importUtil.getCellValue(row,33));//停电范围
                project.setProjectType((String)importUtil.getCellValue(row,34));//项目类型
                project.setPowerFlagPackage((String)importUtil.getCellValue(row,35));//是否为停电打包项目
                project.setPreliminaryJudgment((String)importUtil.getCellValue(row,36));//证处初步判断
                project.setFlagCivilEngineering((String)importUtil.getCellValue(row,37));//是否含土建
                project.setSteelTubePole((String)importUtil.getCellValue(row,38));//钢管杆基础类型
                project.setFlagApprovalPlanning((String)importUtil.getCellValue(row,39));//是否需要规划报批
                project.setEquCreateType((String)importUtil.getCellValue(row,40));//设备改造类型
                project.setEquCreateSize((String)importUtil.getCellValue(row,41));//间隔数
                project.setFlagNewEquName((String)importUtil.getCellValue(row,42));//是否新设备命名
                project.setIncludeBdzNews((String)importUtil.getCellValue(row,43));//是否含变电站新闻格投运
                project.setFlagNoElectrical((String)importUtil.getCellValue(row,44));//是否非射电电气施工
                project.setDrawingsWork((String)importUtil.getCellValue(row,45));//图纸标注的带点作业情况
                project.setFlagAutomation((String)importUtil.getCellValue(row,46));//是否含自动化
                project.setTwoAndThreeRemote((String)importUtil.getCellValue(row,47));//二遥或三
                project.setPhoneStyle((String)importUtil.getCellValue(row,48));//通信方式
                project.setStayOpenArea((String)importUtil.getCellValue(row,49));//柱开集中或就业地
                project.setRingNetworkCabinet((String)importUtil.getCellValue(row,50));//环网柜
                project.setStationDtu((String)importUtil.getCellValue(row,51));//站房dtu
                project.setStatus("0");
                list.add(project);
            }
        }
        return list;
    }
    //验证表格数据是否正确
    public static Boolean getProjectUtilFlag(ImportUtil importUtil){
        Boolean flag = false;
        Row row = importUtil.getRow(1);
        String indexFive =  (String)importUtil.getCellValue(row,5);
        String indexSix = (String)importUtil.getCellValue(row,6);
        String indexNine = (String)importUtil.getCellValue(row,9);
        if (!indexFive.contains("项目")){
            flag = true;
        }
        if (!indexSix.contains("编号")){
            flag = true;
        }
        if (!indexNine.contains("角色")){
            flag = true;
        }
        return flag;
    }

    /*
        对值进行验证
     */
    public static Boolean getJudgeValue(List<Project> projects){
        Boolean flag = false;
        for (Project project:projects){
            if (null==project.getDistributionEngineering()){//配网工程专职角色
                flag = true;
            }
            if (null==project.getDistributionMaterials()){//配网物资专职角色
                flag = true;
            }
            if (null==project.getDistributionSystem()){//配网系统专职角色
                flag = true;
            }
            if (null==project.getDistributionPolicy()){//配网政策处理专职角色
                flag = true;
            }
            if (null==project.getManagementLeader()){//项目管理中心领导角色
                flag = true;
            }
            if (null==project.getRunUnit()){//运行单位
                flag = true;
            }
            if (null==project.getRunUnitRole()){//运行单位角色
                flag = true;
            }
            if (null==project.getThroughResearchRole()){//经研所角色
                flag = true;
            }
            if (null==project.getConstructionUnit()){//施工单位
                flag = true;
            }
            if (null==project.getConstructionUnitRole()){//施工单位:施工单位角色
                flag = true;
            }
            if (null==project.getDesignUnit()){//设计单位
                flag = true;
            }
            if (null==project.getDesignUnitRole()){//设计单位角色
                flag = true;
            }
            if (flag){
                break;
            }
            if (null!=project.getType()){
                flag = getJudge(project.getType(), PRO_TYPE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getDemandUnit()){
                flag = getJudge(project.getDemandUnit(),PRO_NAME);
                if (flag){
                    break;
                }
            }
//            if (null!=project.getProjectManageRole()){//项目经理角色
//                String loginName = UserUtils.getUser().getLoginName();
//                if (!loginName.equals(project.getProjectManageRole())){
//                    flag= true;
//                }
//            }
            if (null!=project.getClarificaitonType()){//交底类型
                flag = getJudge(project.getClarificaitonType(),PRO_CLARIFICAITON);
                if (flag){
                    break;
                }
            }
            if (null!=project.getPowerScope()){//停电范围
                flag = getJudge(project.getPowerScope(), PRO_POWERSCOPE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getProjectType()){//项目类型
                flag = getJudge(project.getProjectType(), PRO_PROJECT_TYPE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getPowerFlagPackage()){//是否为停电打包项目
                flag = getJudge(project.getPowerFlagPackage(), PRO_FLAG);
                if (flag){
                    break;
                }
            }
            if (null!=project.getPreliminaryJudgment()){//政策初步判断
                flag = getJudge(project.getPreliminaryJudgment(), PRO_PRE_JUDGEMENT);
                if (flag){
                    break;
                }
            }
            if (null!=project.getFlagCivilEngineering()){//是否含土建
                flag = getJudge(project.getFlagCivilEngineering(),PRO_FLAG_CIVIL);
                if (flag){
                    break;
                }
            }
            if (null!=project.getSteelTubePole()){//钢管杆基础类类型
                flag = getJudge(project.getSteelTubePole(),PRO_STEEL_TUBE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getFlagApprovalPlanning()){//是否需要规划报批
                flag = getJudge(project.getFlagApprovalPlanning(),PRO_FLAG);
                if (flag){
                    break;
                }
            }
            if (null!=project.getEquCreateType()){//设备改造类型
                flag = getJudge(project.getEquCreateType(),PRO_EQU_TYPE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getFlagNewEquName()){//是否含新设备命名
                flag = getJudge(project.getFlagNewEquName(),PRO_FLAG);
                if (flag){
                    break;
                }
            }
            if (null!=project.getIncludeBdzNews()){//是否含变电站新间间隔投运
                flag = getJudge(project.getIncludeBdzNews(),PRO_FLAG);
                if (flag){
                    break;
                }
            }
            if (null!=project.getFlagNoElectrical()){//是否含非设电电气施工
                flag = getJudge(project.getFlagNoElectrical(),PRO_FLAG);
                if (flag){
                    break;
                }
            }
            if (null!=project.getDrawingsWork()){//图纸标注的带点作业情况
                flag = getJudge(project.getDrawingsWork(),PRO_DRAWING_WORK);
                if (flag){
                    break;
                }
            }
            if (null!=project.getFlagAutomation()){//是否含自动化
                flag = getJudge(project.getFlagAutomation(),PRO_FLAG);
                if (flag){
                    break;
                }
            }
            if (null!=project.getTwoAndThreeRemote()){//二或三
                flag = getJudge(project.getTwoAndThreeRemote(),PRO_TWO_THREE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getPhoneStyle()){//通信方式
                flag = getJudge(project.getPhoneStyle(),PRO_PHONE_STYLE);
                if (flag){
                    break;
                }
            }
            if (null!=project.getStayOpenArea()){//柱开集中或就业地
                flag = getJudge(project.getStayOpenArea(),PRO_STAY_AREA);
                if (flag){
                    break;
                }
            }
            if (null!=project.getRingNetworkCabinet()){//环网柜
                flag = getJudge(project.getRingNetworkCabinet(),PRO_RING_NETWORK);
                if (flag){
                    break;
                }
            }

        }
        return flag;
    }

    public static Boolean getJudge(String name,String[] strings){
        boolean flag = true;
        if (null!=name){
            for (String str:strings){
                if (str.equals(name)){
                    flag = false;
                    break;
                }
            }
        }
        return flag;
    }

    public static Boolean getJudgeCheck(String[] strings){
        boolean flag = false;
        for (String str:strings){
            if (null==str){
                flag = true;
                break;
            }
        }
        return flag;
    }
    /**
     * 生成随机数
     * @return
     */
    public static String getStatus(){
        int machineId = 1;
        int hashCodeV = UUID.randomUUID().toString().hashCode();
        if (hashCodeV<0){
            hashCodeV=-hashCodeV;
        }
        return  (machineId+String.format("%015d",hashCodeV));
    }
    public static List<Project> getSureProjects(List<Project> projects){
        String loginName = UserUtils.getUser().getLoginName();
        for (int i = 0; i < projects.size(); i++) {
            if (null!=projects.get(i).getProjectManageRole()){//项目经理角色
                if (!loginName.equals(projects.get(i).getProjectManageRole())){
                    projects.remove(i);
                    i--;
                }
            }
        }
        return projects;
    }
}
